import { Consumer, FC } from 'react';
import { LiffConfig, Loginable } from './types';
interface LiffProviderProps<T> extends LiffConfig {
    stubEnabled?: boolean | Partial<T>;
}
interface LiffContext<T> {
    error?: unknown;
    isLoggedIn: boolean;
    liff: T;
    ready: boolean;
}
declare type CreateLiffContext = <T extends Loginable>() => {
    LiffConsumer: Consumer<LiffContext<T>>;
    LiffProvider: FC<LiffProviderProps<T>>;
    useLiff: () => LiffContext<T>;
};
export declare const createLiffContext: CreateLiffContext;
export declare const LiffConsumer: Consumer<LiffContext<import("@line/liff").Liff>>, LiffProvider: FC<LiffProviderProps<import("@line/liff").Liff>>, useLiff: () => LiffContext<import("@line/liff").Liff>;
export {};
